import { Index } from './indexed.mjs';
import { MappedResult } from '../mapped/index.mjs';
// prettier-ignore
function MappedIndexPropertyKey(T, K, options) {
    return { [K]: Index(T, [K], options) };
}
// prettier-ignore
function MappedIndexPropertyKeys(T, K, options, Acc = {}) {
    const [L, ...R] = K;
    return (K.length > 0
        ? MappedIndexPropertyKeys(T, R, options, { ...Acc, ...MappedIndexPropertyKey(T, L, options) })
        : Acc);
}
// prettier-ignore
function MappedIndexProperties(T, K, options) {
    return MappedIndexPropertyKeys(T, K.keys, options);
}
// prettier-ignore
export function IndexFromMappedKey(T, K, options) {
    const P = MappedIndexProperties(T, K, options);
    return MappedResult(P);
}
