import type { SchemaOptions } from '../schema/index.mjs';
import type { TProperties } from '../object/index.mjs';
import { type TMappedResult } from '../mapped/index.mjs';
import { type TKeyOf } from './keyof.mjs';
type TFromProperties<K extends TProperties> = ({
    [K2 in keyof K]: TKeyOf<K[K2]>;
});
type TFromMappedResult<K extends TMappedResult> = (TFromProperties<K['properties']>);
export type TKeyOfFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>> = (TMappedResult<P>);
export declare function KeyOfFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>>(T: T, options: SchemaOptions): TMappedResult<P>;
export {};
