import { Literal } from '../literal/index.mjs';
import { Number } from '../number/index.mjs';
import { KeyOfPropertyKeys } from './keyof-property-keys.mjs';
import { UnionEvaluated } from '../union/index.mjs';
import { CloneType } from '../clone/type.mjs';
import { KeyOfFromMappedResult } from './keyof-from-mapped-result.mjs';
// ------------------------------------------------------------------
// TypeGuard
// ------------------------------------------------------------------
// prettier-ignore
import { IsMappedResult } from '../guard/type.mjs';
// prettier-ignore
function FromPropertyKeys(T, Acc = []) {
    const [L, ...R] = T;
    return (T.length > 0
        ? L === '[number]'
            ? FromPropertyKeys(R, [...Acc, Number()])
            : FromPropertyKeys(R, [...Acc, Literal(L)])
        : Acc);
}
/** `[Json]` Creates a KeyOf type */
export function KeyOf(T, options = {}) {
    if (IsMappedResult(T)) {
        return KeyOfFromMappedResult(T, options);
    }
    else {
        const K = KeyOfPropertyKeys(T);
        const S = FromPropertyKeys(K);
        const U = UnionEvaluated(S);
        return CloneType(U, options);
    }
}
