import type { SchemaOptions } from '../schema/index.mjs';
import type { TProperties } from '../object/index.mjs';
import { type TMappedResult } from '../mapped/index.mjs';
import { type TPartial } from './partial.mjs';
type TFromProperties<K extends TProperties> = ({
    [K2 in keyof K]: TPartial<K[K2]>;
});
type TFromMappedResult<K extends TMappedResult> = (TFromProperties<K['properties']>);
export type TPartialFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>> = (TMappedResult<P>);
export declare function PartialFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>>(T: T, options: SchemaOptions): TMappedResult<P>;
export {};
