import { MappedResult } from '../mapped/index.mjs';
import { Pick } from './pick.mjs';
// prettier-ignore
function FromPropertyKey(T, K, options) {
    return {
        [K]: Pick(T, [K], options)
    };
}
// prettier-ignore
function FromPropertyKeys(T, K, options, Acc = {}) {
    const [LK, ...RK] = K;
    return (K.length > 0
        ? FromPropertyKeys(T, RK, options, { ...Acc, ...FromPropertyKey(T, LK, options) })
        : Acc);
}
// prettier-ignore
function FromMappedKey(T, K, options) {
    return FromPropertyKeys(T, K.keys, options);
}
// prettier-ignore
export function PickFromMappedKey(T, K, options) {
    const P = FromMappedKey(T, K, options);
    return MappedResult(P);
}
