import type { SchemaOptions } from '../schema/index.mjs';
import type { TProperties } from '../object/index.mjs';
import { type TMappedResult } from '../mapped/index.mjs';
import { type TRequired } from './required.mjs';
type TFromProperties<K extends TProperties> = ({
    [K2 in keyof K]: TRequired<K[K2]>;
});
type TFromMappedResult<K extends TMappedResult> = (TFromProperties<K['properties']>);
export type TRequiredFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>> = (TMappedResult<P>);
export declare function RequiredFromMappedResult<T extends TMappedResult, P extends TProperties = TFromMappedResult<T>>(T: T, options: SchemaOptions): TMappedResult<P>;
export {};
