import type { Static } from '../../type/static/index.mjs';
import { TypeBoxError } from '../../type/error/index.mjs';
export type Insert = Static<typeof Insert>;
export declare const Insert: import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"insert">;
    path: import("../../type/string/string.mjs").TString;
    value: import("../../type/unknown/unknown.mjs").TUnknown;
}>;
export type Update = Static<typeof Update>;
export declare const Update: import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"update">;
    path: import("../../type/string/string.mjs").TString;
    value: import("../../type/unknown/unknown.mjs").TUnknown;
}>;
export type Delete = Static<typeof Delete>;
export declare const Delete: import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"delete">;
    path: import("../../type/string/string.mjs").TString;
}>;
export type Edit = Static<typeof Edit>;
export declare const Edit: import("../../type/union/union-type.mjs").TUnion<[import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"insert">;
    path: import("../../type/string/string.mjs").TString;
    value: import("../../type/unknown/unknown.mjs").TUnknown;
}>, import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"update">;
    path: import("../../type/string/string.mjs").TString;
    value: import("../../type/unknown/unknown.mjs").TUnknown;
}>, import("../../type/object/object.mjs").TObject<{
    type: import("../../type/literal/literal.mjs").TLiteral<"delete">;
    path: import("../../type/string/string.mjs").TString;
}>]>;
export declare class ValueDeltaObjectWithSymbolKeyError extends TypeBoxError {
    readonly key: unknown;
    constructor(key: unknown);
}
export declare class ValueDeltaUnableToDiffUnknownValue extends TypeBoxError {
    readonly value: unknown;
    constructor(value: unknown);
}
export declare function Diff(current: unknown, next: unknown): Edit[];
export declare function Patch<T = any>(current: unknown, edits: Edit[]): T;
