"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.IntrinsicFromMappedKey = exports.Intrinsic = exports.Iterator = exports.IntersectEvaluated = exports.Intersect = exports.Integer = exports.InstanceType = exports.IndexFromMappedResult = exports.IndexFromMappedKey = exports.IndexPropertyKeys = exports.Index = exports.Increment = exports.Function = exports.Extract = exports.ExtendsUndefinedCheck = exports.ExtendsResult = exports.ExtendsCheck = exports.Extends = exports.Exclude = exports.Enum = exports.Deref = exports.Date = exports.ConstructorParameters = exports.Constructor = exports.Const = exports.Composite = exports.Boolean = exports.BigInt = exports.Awaited = exports.AsyncIterator = exports.Array = exports.Any = exports.TypeBoxError = exports.CloneRest = exports.CloneType = exports.ValueGuard = exports.TypeGuard = exports.FormatRegistry = exports.TypeRegistry = exports.PatternStringExact = exports.PatternString = exports.PatternNumberExact = exports.PatternNumber = exports.PatternBooleanExact = exports.PatternBoolean = exports.TransformKind = exports.OptionalKind = exports.ReadonlyKind = exports.Hint = exports.Kind = void 0;
exports.Undefined = exports.Uint8Array = exports.Tuple = exports.TransformEncodeBuilder = exports.TransformDecodeBuilder = exports.Transform = exports.TemplateLiteralExpressionGenerate = exports.TemplateLiteralGenerate = exports.TemplateLiteralParseExact = exports.TemplateLiteralParse = exports.IsTemplateLiteralExpressionFinite = exports.IsTemplateLiteralFinite = exports.TemplateLiteral = exports.Symbol = exports.String = exports.Strict = exports.ReturnType = exports.Rest = exports.Required = exports.RegExp = exports.Ref = exports.Recursive = exports.Record = exports.ReadonlyOptional = exports.ReadonlyFromMappedResult = exports.Readonly = exports.Promise = exports.Pick = exports.PartialFromMappedResult = exports.Partial = exports.Parameters = exports.OptionalFromMappedResult = exports.Optional = exports.Omit = exports.Object = exports.Number = exports.Null = exports.Not = exports.Never = exports.MappedResult = exports.MappedKey = exports.Mapped = exports.Literal = exports.KeyOfPattern = exports.KeyOfPropertyKeys = exports.KeyOf = exports.Uppercase = exports.Uncapitalize = exports.Lowercase = exports.Capitalize = void 0;
exports.JavaScriptTypeBuilder = exports.JsonTypeBuilder = exports.Type = exports.Void = exports.Unsafe = exports.Unknown = exports.UnionEvaluated = exports.Union = void 0;
// ------------------------------------------------------------------
// Infrastructure
// ------------------------------------------------------------------
var index_1 = require("./type/symbols/index");
Object.defineProperty(exports, "Kind", { enumerable: true, get: function () { return index_1.Kind; } });
Object.defineProperty(exports, "Hint", { enumerable: true, get: function () { return index_1.Hint; } });
Object.defineProperty(exports, "ReadonlyKind", { enumerable: true, get: function () { return index_1.ReadonlyKind; } });
Object.defineProperty(exports, "OptionalKind", { enumerable: true, get: function () { return index_1.OptionalKind; } });
Object.defineProperty(exports, "TransformKind", { enumerable: true, get: function () { return index_1.TransformKind; } });
var index_2 = require("./type/patterns/index");
Object.defineProperty(exports, "PatternBoolean", { enumerable: true, get: function () { return index_2.PatternBoolean; } });
Object.defineProperty(exports, "PatternBooleanExact", { enumerable: true, get: function () { return index_2.PatternBooleanExact; } });
Object.defineProperty(exports, "PatternNumber", { enumerable: true, get: function () { return index_2.PatternNumber; } });
Object.defineProperty(exports, "PatternNumberExact", { enumerable: true, get: function () { return index_2.PatternNumberExact; } });
Object.defineProperty(exports, "PatternString", { enumerable: true, get: function () { return index_2.PatternString; } });
Object.defineProperty(exports, "PatternStringExact", { enumerable: true, get: function () { return index_2.PatternStringExact; } });
var index_3 = require("./type/registry/index");
Object.defineProperty(exports, "TypeRegistry", { enumerable: true, get: function () { return index_3.TypeRegistry; } });
Object.defineProperty(exports, "FormatRegistry", { enumerable: true, get: function () { return index_3.FormatRegistry; } });
var index_4 = require("./type/guard/index");
Object.defineProperty(exports, "TypeGuard", { enumerable: true, get: function () { return index_4.TypeGuard; } });
Object.defineProperty(exports, "ValueGuard", { enumerable: true, get: function () { return index_4.ValueGuard; } });
var type_1 = require("./type/clone/type");
Object.defineProperty(exports, "CloneType", { enumerable: true, get: function () { return type_1.CloneType; } });
Object.defineProperty(exports, "CloneRest", { enumerable: true, get: function () { return type_1.CloneRest; } });
var index_5 = require("./type/error/index");
Object.defineProperty(exports, "TypeBoxError", { enumerable: true, get: function () { return index_5.TypeBoxError; } });
// ------------------------------------------------------------------
// Type
// ------------------------------------------------------------------
var index_6 = require("./type/any/index");
Object.defineProperty(exports, "Any", { enumerable: true, get: function () { return index_6.Any; } });
var index_7 = require("./type/array/index");
Object.defineProperty(exports, "Array", { enumerable: true, get: function () { return index_7.Array; } });
var index_8 = require("./type/async-iterator/index");
Object.defineProperty(exports, "AsyncIterator", { enumerable: true, get: function () { return index_8.AsyncIterator; } });
var index_9 = require("./type/awaited/index");
Object.defineProperty(exports, "Awaited", { enumerable: true, get: function () { return index_9.Awaited; } });
var index_10 = require("./type/bigint/index");
Object.defineProperty(exports, "BigInt", { enumerable: true, get: function () { return index_10.BigInt; } });
var index_11 = require("./type/boolean/index");
Object.defineProperty(exports, "Boolean", { enumerable: true, get: function () { return index_11.Boolean; } });
var index_12 = require("./type/composite/index");
Object.defineProperty(exports, "Composite", { enumerable: true, get: function () { return index_12.Composite; } });
var index_13 = require("./type/const/index");
Object.defineProperty(exports, "Const", { enumerable: true, get: function () { return index_13.Const; } });
var index_14 = require("./type/constructor/index");
Object.defineProperty(exports, "Constructor", { enumerable: true, get: function () { return index_14.Constructor; } });
var index_15 = require("./type/constructor-parameters/index");
Object.defineProperty(exports, "ConstructorParameters", { enumerable: true, get: function () { return index_15.ConstructorParameters; } });
var index_16 = require("./type/date/index");
Object.defineProperty(exports, "Date", { enumerable: true, get: function () { return index_16.Date; } });
var index_17 = require("./type/deref/index");
Object.defineProperty(exports, "Deref", { enumerable: true, get: function () { return index_17.Deref; } });
var index_18 = require("./type/enum/index");
Object.defineProperty(exports, "Enum", { enumerable: true, get: function () { return index_18.Enum; } });
var index_19 = require("./type/exclude/index");
Object.defineProperty(exports, "Exclude", { enumerable: true, get: function () { return index_19.Exclude; } });
var index_20 = require("./type/extends/index");
Object.defineProperty(exports, "Extends", { enumerable: true, get: function () { return index_20.Extends; } });
Object.defineProperty(exports, "ExtendsCheck", { enumerable: true, get: function () { return index_20.ExtendsCheck; } });
Object.defineProperty(exports, "ExtendsResult", { enumerable: true, get: function () { return index_20.ExtendsResult; } });
Object.defineProperty(exports, "ExtendsUndefinedCheck", { enumerable: true, get: function () { return index_20.ExtendsUndefinedCheck; } });
var index_21 = require("./type/extract/index");
Object.defineProperty(exports, "Extract", { enumerable: true, get: function () { return index_21.Extract; } });
var index_22 = require("./type/function/index");
Object.defineProperty(exports, "Function", { enumerable: true, get: function () { return index_22.Function; } });
var index_23 = require("./type/helpers/index");
Object.defineProperty(exports, "Increment", { enumerable: true, get: function () { return index_23.Increment; } });
var index_24 = require("./type/indexed/index");
Object.defineProperty(exports, "Index", { enumerable: true, get: function () { return index_24.Index; } });
Object.defineProperty(exports, "IndexPropertyKeys", { enumerable: true, get: function () { return index_24.IndexPropertyKeys; } });
Object.defineProperty(exports, "IndexFromMappedKey", { enumerable: true, get: function () { return index_24.IndexFromMappedKey; } });
Object.defineProperty(exports, "IndexFromMappedResult", { enumerable: true, get: function () { return index_24.IndexFromMappedResult; } });
var index_25 = require("./type/instance-type/index");
Object.defineProperty(exports, "InstanceType", { enumerable: true, get: function () { return index_25.InstanceType; } });
var index_26 = require("./type/integer/index");
Object.defineProperty(exports, "Integer", { enumerable: true, get: function () { return index_26.Integer; } });
var index_27 = require("./type/intersect/index");
Object.defineProperty(exports, "Intersect", { enumerable: true, get: function () { return index_27.Intersect; } });
Object.defineProperty(exports, "IntersectEvaluated", { enumerable: true, get: function () { return index_27.IntersectEvaluated; } });
var index_28 = require("./type/iterator/index");
Object.defineProperty(exports, "Iterator", { enumerable: true, get: function () { return index_28.Iterator; } });
var index_29 = require("./type/intrinsic/index");
Object.defineProperty(exports, "Intrinsic", { enumerable: true, get: function () { return index_29.Intrinsic; } });
Object.defineProperty(exports, "IntrinsicFromMappedKey", { enumerable: true, get: function () { return index_29.IntrinsicFromMappedKey; } });
Object.defineProperty(exports, "Capitalize", { enumerable: true, get: function () { return index_29.Capitalize; } });
Object.defineProperty(exports, "Lowercase", { enumerable: true, get: function () { return index_29.Lowercase; } });
Object.defineProperty(exports, "Uncapitalize", { enumerable: true, get: function () { return index_29.Uncapitalize; } });
Object.defineProperty(exports, "Uppercase", { enumerable: true, get: function () { return index_29.Uppercase; } });
var index_30 = require("./type/keyof/index");
Object.defineProperty(exports, "KeyOf", { enumerable: true, get: function () { return index_30.KeyOf; } });
Object.defineProperty(exports, "KeyOfPropertyKeys", { enumerable: true, get: function () { return index_30.KeyOfPropertyKeys; } });
Object.defineProperty(exports, "KeyOfPattern", { enumerable: true, get: function () { return index_30.KeyOfPattern; } });
var index_31 = require("./type/literal/index");
Object.defineProperty(exports, "Literal", { enumerable: true, get: function () { return index_31.Literal; } });
var index_32 = require("./type/mapped/index");
Object.defineProperty(exports, "Mapped", { enumerable: true, get: function () { return index_32.Mapped; } });
Object.defineProperty(exports, "MappedKey", { enumerable: true, get: function () { return index_32.MappedKey; } });
Object.defineProperty(exports, "MappedResult", { enumerable: true, get: function () { return index_32.MappedResult; } });
var index_33 = require("./type/never/index");
Object.defineProperty(exports, "Never", { enumerable: true, get: function () { return index_33.Never; } });
var index_34 = require("./type/not/index");
Object.defineProperty(exports, "Not", { enumerable: true, get: function () { return index_34.Not; } });
var index_35 = require("./type/null/index");
Object.defineProperty(exports, "Null", { enumerable: true, get: function () { return index_35.Null; } });
var index_36 = require("./type/number/index");
Object.defineProperty(exports, "Number", { enumerable: true, get: function () { return index_36.Number; } });
var index_37 = require("./type/object/index");
Object.defineProperty(exports, "Object", { enumerable: true, get: function () { return index_37.Object; } });
var index_38 = require("./type/omit/index");
Object.defineProperty(exports, "Omit", { enumerable: true, get: function () { return index_38.Omit; } });
var index_39 = require("./type/optional/index");
Object.defineProperty(exports, "Optional", { enumerable: true, get: function () { return index_39.Optional; } });
Object.defineProperty(exports, "OptionalFromMappedResult", { enumerable: true, get: function () { return index_39.OptionalFromMappedResult; } });
var index_40 = require("./type/parameters/index");
Object.defineProperty(exports, "Parameters", { enumerable: true, get: function () { return index_40.Parameters; } });
var index_41 = require("./type/partial/index");
Object.defineProperty(exports, "Partial", { enumerable: true, get: function () { return index_41.Partial; } });
Object.defineProperty(exports, "PartialFromMappedResult", { enumerable: true, get: function () { return index_41.PartialFromMappedResult; } });
var index_42 = require("./type/pick/index");
Object.defineProperty(exports, "Pick", { enumerable: true, get: function () { return index_42.Pick; } });
var index_43 = require("./type/promise/index");
Object.defineProperty(exports, "Promise", { enumerable: true, get: function () { return index_43.Promise; } });
var index_44 = require("./type/readonly/index");
Object.defineProperty(exports, "Readonly", { enumerable: true, get: function () { return index_44.Readonly; } });
Object.defineProperty(exports, "ReadonlyFromMappedResult", { enumerable: true, get: function () { return index_44.ReadonlyFromMappedResult; } });
var index_45 = require("./type/readonly-optional/index");
Object.defineProperty(exports, "ReadonlyOptional", { enumerable: true, get: function () { return index_45.ReadonlyOptional; } });
var index_46 = require("./type/record/index");
Object.defineProperty(exports, "Record", { enumerable: true, get: function () { return index_46.Record; } });
var index_47 = require("./type/recursive/index");
Object.defineProperty(exports, "Recursive", { enumerable: true, get: function () { return index_47.Recursive; } });
var index_48 = require("./type/ref/index");
Object.defineProperty(exports, "Ref", { enumerable: true, get: function () { return index_48.Ref; } });
var index_49 = require("./type/regexp/index");
Object.defineProperty(exports, "RegExp", { enumerable: true, get: function () { return index_49.RegExp; } });
var index_50 = require("./type/required/index");
Object.defineProperty(exports, "Required", { enumerable: true, get: function () { return index_50.Required; } });
var index_51 = require("./type/rest/index");
Object.defineProperty(exports, "Rest", { enumerable: true, get: function () { return index_51.Rest; } });
var index_52 = require("./type/return-type/index");
Object.defineProperty(exports, "ReturnType", { enumerable: true, get: function () { return index_52.ReturnType; } });
var index_53 = require("./type/strict/index");
Object.defineProperty(exports, "Strict", { enumerable: true, get: function () { return index_53.Strict; } });
var index_54 = require("./type/string/index");
Object.defineProperty(exports, "String", { enumerable: true, get: function () { return index_54.String; } });
var index_55 = require("./type/symbol/index");
Object.defineProperty(exports, "Symbol", { enumerable: true, get: function () { return index_55.Symbol; } });
var index_56 = require("./type/template-literal/index");
Object.defineProperty(exports, "TemplateLiteral", { enumerable: true, get: function () { return index_56.TemplateLiteral; } });
Object.defineProperty(exports, "IsTemplateLiteralFinite", { enumerable: true, get: function () { return index_56.IsTemplateLiteralFinite; } });
Object.defineProperty(exports, "IsTemplateLiteralExpressionFinite", { enumerable: true, get: function () { return index_56.IsTemplateLiteralExpressionFinite; } });
Object.defineProperty(exports, "TemplateLiteralParse", { enumerable: true, get: function () { return index_56.TemplateLiteralParse; } });
Object.defineProperty(exports, "TemplateLiteralParseExact", { enumerable: true, get: function () { return index_56.TemplateLiteralParseExact; } });
Object.defineProperty(exports, "TemplateLiteralGenerate", { enumerable: true, get: function () { return index_56.TemplateLiteralGenerate; } });
Object.defineProperty(exports, "TemplateLiteralExpressionGenerate", { enumerable: true, get: function () { return index_56.TemplateLiteralExpressionGenerate; } });
var index_57 = require("./type/transform/index");
Object.defineProperty(exports, "Transform", { enumerable: true, get: function () { return index_57.Transform; } });
Object.defineProperty(exports, "TransformDecodeBuilder", { enumerable: true, get: function () { return index_57.TransformDecodeBuilder; } });
Object.defineProperty(exports, "TransformEncodeBuilder", { enumerable: true, get: function () { return index_57.TransformEncodeBuilder; } });
var index_58 = require("./type/tuple/index");
Object.defineProperty(exports, "Tuple", { enumerable: true, get: function () { return index_58.Tuple; } });
var index_59 = require("./type/uint8array/index");
Object.defineProperty(exports, "Uint8Array", { enumerable: true, get: function () { return index_59.Uint8Array; } });
var index_60 = require("./type/undefined/index");
Object.defineProperty(exports, "Undefined", { enumerable: true, get: function () { return index_60.Undefined; } });
var index_61 = require("./type/union/index");
Object.defineProperty(exports, "Union", { enumerable: true, get: function () { return index_61.Union; } });
Object.defineProperty(exports, "UnionEvaluated", { enumerable: true, get: function () { return index_61.UnionEvaluated; } });
var index_62 = require("./type/unknown/index");
Object.defineProperty(exports, "Unknown", { enumerable: true, get: function () { return index_62.Unknown; } });
var index_63 = require("./type/unsafe/index");
Object.defineProperty(exports, "Unsafe", { enumerable: true, get: function () { return index_63.Unsafe; } });
var index_64 = require("./type/void/index");
Object.defineProperty(exports, "Void", { enumerable: true, get: function () { return index_64.Void; } });
// ------------------------------------------------------------------
// Namespace
// ------------------------------------------------------------------
var index_65 = require("./type/type/index");
Object.defineProperty(exports, "Type", { enumerable: true, get: function () { return index_65.Type; } });
Object.defineProperty(exports, "JsonTypeBuilder", { enumerable: true, get: function () { return index_65.JsonTypeBuilder; } });
Object.defineProperty(exports, "JavaScriptTypeBuilder", { enumerable: true, get: function () { return index_65.JavaScriptTypeBuilder; } });
