"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Awaited = void 0;
const index_1 = require("../intersect/index");
const index_2 = require("../union/index");
const type_1 = require("../clone/type");
// ------------------------------------------------------------------
// TypeGuard
// ------------------------------------------------------------------
// prettier-ignore
const type_2 = require("../guard/type");
// prettier-ignore
function FromRest(T, Acc = []) {
    const [L, ...R] = T;
    return (T.length > 0
        ? FromRest(R, [...Acc, FromSchema(L)])
        : Acc);
}
// prettier-ignore
function FromIntersect(T) {
    return (0, index_1.Intersect)(FromRest(T));
}
// prettier-ignore
function FromUnion(T) {
    return (0, index_2.Union)(FromRest(T));
}
// prettier-ignore
function FromPromise(T) {
    return FromSchema(T);
}
// prettier-ignore
function FromSchema(T) {
    return ((0, type_2.IsIntersect)(T) ? FromIntersect(T.allOf) :
        (0, type_2.IsUnion)(T) ? FromUnion(T.anyOf) :
            (0, type_2.IsPromise)(T) ? FromPromise(T.item) :
                T);
}
/** `[JavaScript]` Constructs a type by recursively unwrapping Promise types */
function Awaited(T, options = {}) {
    return (0, type_1.CloneType)(FromSchema(T), options);
}
exports.Awaited = Awaited;
