"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Composite = exports.CompositeResolve = void 0;
const index_1 = require("../object/index");
const index_2 = require("../intersect/index");
const index_3 = require("../keyof/index");
const index_4 = require("../indexed/index");
const type_1 = require("../clone/type");
function CompositeResolve(T) {
    const intersect = (0, index_2.Intersect)(T, {});
    const keys = (0, index_3.KeyOfPropertyKeys)(intersect);
    const properties = keys.reduce((acc, key) => ({ ...acc, [key]: (0, index_4.Index)(intersect, [key]) }), {});
    return (0, index_1.Object)(properties);
}
exports.CompositeResolve = CompositeResolve;
/** `[Json]` Creates a Composite object type */
function Composite(T, options) {
    return (0, type_1.CloneType)(CompositeResolve(T), options);
}
exports.Composite = Composite;
