"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.ExcludeFromMappedResult = void 0;
const index_1 = require("../mapped/index");
const exclude_1 = require("./exclude");
// prettier-ignore
function FromProperties(K, U, options) {
    return globalThis.Object.getOwnPropertyNames(K).reduce((Acc, K2) => {
        return { ...Acc, [K2]: (0, exclude_1.Exclude)(K[K2], U, options) };
    }, {});
}
// prettier-ignore
function FromMappedResult(K, U, options) {
    return FromProperties(K.properties, U, options);
}
// prettier-ignore
function ExcludeFromMappedResult(T, U, options) {
    const P = FromMappedResult(T, U, options);
    return (0, index_1.MappedResult)(P);
}
exports.ExcludeFromMappedResult = ExcludeFromMappedResult;
