"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Extract = exports.ExtractResolve = void 0;
const index_1 = require("../template-literal/index");
const index_2 = require("../union/index");
const index_3 = require("../never/index");
const index_4 = require("../extends/index");
const type_1 = require("../clone/type");
const extract_from_mapped_result_1 = require("./extract-from-mapped-result");
// prettier-ignore
const type_2 = require("../guard/type");
// prettier-ignore
function ExtractResolve(L, R) {
    return ((0, type_2.IsTemplateLiteral)(L) ? ExtractResolve((0, index_1.TemplateLiteralToUnion)(L), R) :
        (0, type_2.IsTemplateLiteral)(R) ? ExtractResolve(L, (0, index_1.TemplateLiteralToUnion)(R)) :
            (0, type_2.IsUnion)(L) ? (() => {
                const narrowed = L.anyOf.filter((inner) => (0, index_4.ExtendsCheck)(inner, R) !== index_4.ExtendsResult.False);
                return (narrowed.length === 1 ? narrowed[0] : (0, index_2.Union)(narrowed));
            })() :
                (0, index_4.ExtendsCheck)(L, R) !== index_4.ExtendsResult.False ? L :
                    (0, index_3.Never)());
}
exports.ExtractResolve = ExtractResolve;
/** `[Json]` Constructs a type by extracting from type all union members that are assignable to union */
function Extract(type, union, options = {}) {
    if ((0, type_2.IsMappedResult)(type)) {
        return (0, extract_from_mapped_result_1.ExtractFromMappedResult)(type, union, options);
    }
    else {
        const E = ExtractResolve(type, union);
        return (0, type_1.CloneType)(E, options);
    }
}
exports.Extract = Extract;
