"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.PartialFromMappedResult = void 0;
const index_1 = require("../mapped/index");
const partial_1 = require("./partial");
// prettier-ignore
function FromProperties(K, options) {
    return globalThis.Object.getOwnPropertyNames(K).reduce((Acc, K2) => {
        return { ...Acc, [K2]: (0, partial_1.Partial)(K[K2], options) };
    }, {});
}
// prettier-ignore
function FromMappedResult(K, options) {
    return FromProperties(K.properties, options);
}
// prettier-ignore
function PartialFromMappedResult(T, options) {
    const P = FromMappedResult(T, options);
    return (0, index_1.MappedResult)(P);
}
exports.PartialFromMappedResult = PartialFromMappedResult;
