"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.UnionEvaluated = void 0;
const index_1 = require("../symbols/index");
const type_1 = require("../clone/type");
const index_2 = require("../discard/index");
const index_3 = require("../never/index");
const index_4 = require("../optional/index");
const union_create_1 = require("./union-create");
// ------------------------------------------------------------------
// TypeGuard
// ------------------------------------------------------------------
// prettier-ignore
const type_2 = require("../guard/type");
// prettier-ignore
function IsUnionOptional(T) {
    const [L, ...R] = T;
    return (T.length > 0
        ? (0, type_2.IsOptional)(L)
            ? true
            : IsUnionOptional(R)
        : false);
}
// prettier-ignore
function RemoveOptionalFromRest(T, Acc = []) {
    const [L, ...R] = T;
    return (T.length > 0
        ? (0, type_2.IsOptional)(L)
            ? RemoveOptionalFromRest(R, [...Acc, RemoveOptionalFromType(L)])
            : RemoveOptionalFromRest(R, [...Acc, L])
        : Acc);
}
// prettier-ignore
function RemoveOptionalFromType(T) {
    return ((0, index_2.Discard)(T, [index_1.OptionalKind]));
}
// prettier-ignore
function ResolveUnion(T, options) {
    return (IsUnionOptional(T)
        ? (0, index_4.Optional)((0, union_create_1.UnionCreate)(RemoveOptionalFromRest(T), options))
        : (0, union_create_1.UnionCreate)(RemoveOptionalFromRest(T), options));
}
/** `[Json]` Creates an evaluated Union type */
function UnionEvaluated(T, options = {}) {
    // prettier-ignore
    return (T.length === 0 ? (0, index_3.Never)(options) :
        T.length === 1 ? (0, type_1.CloneType)(T[0], options) :
            ResolveUnion(T, options));
}
exports.UnionEvaluated = UnionEvaluated;
